con
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

  tiles    = vga#xtiles * vga#ytiles

obj
  vga : "VGA_512x384_Bitmap"

var
  long sync
  byte bytemap[vga#vp * vga#hp >> 3 ]
  word colors[tiles]

pub main | r, x, y
  vga.start(16, @colors, @bytemap, @sync)
  wordfill(@colors, %111111_00_010101_00, tiles)

  repeat
    repeat y from 0 to vga#vp - 1 step 8
      repeat x from 0 to vga#hp - 1 step 8
        if ?r & 1
          bytemap[(y + 0) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
          bytemap[(y + 1) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
          bytemap[(y + 2) << 6 + x >> 3] := %0_0_1_1_0_0_0_0
          bytemap[(y + 3) << 6 + x >> 3] := %1_1_1_0_0_0_1_1
          bytemap[(y + 4) << 6 + x >> 3] := %1_1_0_0_0_1_1_1
          bytemap[(y + 5) << 6 + x >> 3] := %0_0_0_0_1_1_0_0
          bytemap[(y + 6) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
          bytemap[(y + 7) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
        else
          bytemap[(y + 0) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
          bytemap[(y + 1) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
          bytemap[(y + 2) << 6 + x >> 3] := %0_0_0_0_1_1_0_0
          bytemap[(y + 3) << 6 + x >> 3] := %1_1_0_0_0_1_1_1
          bytemap[(y + 4) << 6 + x >> 3] := %1_1_1_0_0_0_1_1
          bytemap[(y + 5) << 6 + x >> 3] := %0_0_1_1_0_0_0_0
          bytemap[(y + 6) << 6 + x >> 3] := %0_0_0_1_1_0_0_0
          bytemap[(y + 7) << 6 + x >> 3] := %0_0_0_1_1_0_0_0

    waitcnt(cnt + _clkfreq)
